<?php
/**
 * @name		Menu Manager CK
 * @package		com_menumanagerck
 * @copyright	Copyright (C) 2014. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 * @author		Cedric Keiflin - http://www.template-creator.com - http://www.joomlack.fr
 */

defined('_JEXEC') or die;
jimport('joomla.application.component.modellist');
require_once (JPATH_ROOT.'/administrator/components/com_menumanagerck/models/custom.php');
require_once (JPATH_ADMINISTRATOR.'/components/com_hikashop/helpers/helper.php');

class MenumanagerckModelCustomhikashopitem extends MenumanagerckModelCustom
{
	protected $context = 'com_menumanagerck.customhikashopitem';

	public $pagination;

	public function __construct($config = array())
	{
		parent::__construct($config);
	}

	public function getCustomColumn()
	{
		return Array('title' => JText::_('JCATEGORY'), 'tag' => 'category_name', 'sort' => 'category_name');
	}

	public function getOrderingColumn()
	{
		return Array('title' => JText::_('JGRID_HEADING_ORDERING'), 'tag' => 'ordering', 'sort' => 'a.ordering');
	}

	public function showSearchBar()
	{
		return true;
	}
	
	public function getCustomFilters()
	{
		$app = JFactory::getApplication();
		$customfilters = '';
		
		// filter for parent category
		$class = hikashop_get('class.category');
		$categories_select = $class->getList('product', 0, false);
		$customfilters = '<select name="filter_id" class="input-medium" onchange="this.form.submit()">'
			. '<option value="0">- ' . JText::_('JCATEGORY') . ' -</option>'
			. JHtml::_('select.options', $categories_select, 'category_id', 'category_name', $this->state->get('filter_id'))
		. '</select>';

		return $customfilters;
	}
	
	/**
	 * Method to get items to list
	 *
	 * @return  array  The items list
	 *
	 */
	public function getItems()
	{
		$items = $this->listing();

		return $items;
	}

	/**
	 * Method to get items associtation, to know what property to use to display the data
	 *
	 * @return  object  The item tags
	 *
	 */
	public function getObjectAssociation() {
		$names = new stdClass();
		$names->title = 'product_name';
		$names->level = 'level';
		$names->language = 'language';
		$names->id = 'id';

		return $names;
	}

	/**
	 * Method to get model state variables
	 *
	 * @param   string  $property  Optional parameter name
	 * @param   mixed   $default   Optional default value
	 *
	 * @return  object  The property where specified, the state object where omitted
	 *
	 * @since   12.2
	 */
	public function getState($property = null, $default = null)
	{
		$this->populateState();

		return $property === null ? $this->state : $this->state->get($property, $default);
	}

	/**
	 * Method to auto-populate the model state.
	 *
	 * Note. Calling getState in this method will result in recursion.
	 *
	 * @param   string  $ordering   An optional ordering field.
	 * @param   string  $direction  An optional direction (asc|desc).
	 *
	 * @return  void
	 *
	 * @since   1.6
	 */
	protected function populateState($ordering = null, $direction = null)
	{
		$app = JFactory::getApplication();

		$search = $this->getUserStateFromRequest($this->context . '.search', 'filter_search');
		$this->setState('filter.search', $search);

		$this->setState('filter_id', $this->getUserStateFromRequest($this->context . '.filter_id', 'filter_id', 0));
		$this->setState('list.limit', $this->getUserStateFromRequest($this->context.'.limit', 'limit', $app->getCfg('list_limit'), 'int' ));
		// List state information.
		$filter_order = $app->getUserStateFromRequest($this->context.'filter_order', 'filter_order', "id", 'cmd');
		$filter_order_Dir = $app->getUserStateFromRequest($this->context.'filter_order_Dir', 'filter_order_Dir', "asc", 'cmd');
		parent::populateState($filter_order, $filter_order_Dir);

	}

	/**
	 * Method to get a store id based on model configuration state.
	 *
	 * This is necessary because the model is used by the component and
	 * different modules that might need different sets of data or different
	 * ordering requirements.
	 *
	 * @param   string  $id  A prefix for the store id.
	 *
	 * @return  string  A store id.
	 *
	 * @since   1.6
	 */
	protected function getStoreId($id = '')
	{
		// Compile the store id.
		$id .= ':' . $this->getState('filter.search');
		$id .= ':' . $this->getState('filter.extension');
		$id .= ':' . $this->getState('filter.published');
		$id .= ':' . $this->getState('filter.language');

		return parent::getStoreId($id);
	}
	
	/**
	 * Method to get a JPagination object for the data set.
	 *
	 * @return  JPagination  A JPagination object for the data set.
	 *
	 * @since   12.2
	 */
	public function getPagination()
	{
		return $this->pagination;
	}

	/**
	 * Method to get the items from the component
	 *
	 * @return  array	the list of items
	 *
	 */
	function listing(){
		$app = JFactory::getApplication();
		$pageInfo = new stdClass();
		$pageInfo->filter = new stdClass();
		$pageInfo->filter->order = new stdClass();
		$pageInfo->limit = new stdClass();
		$config =& hikashop_config();

		$pageInfo->filter->order->value = $app->getUserStateFromRequest( $this->context.".filter_order", 'filter_order',	'a.ordering','cmd' );
		$pageInfo->filter->order->dir	= $app->getUserStateFromRequest( $this->context.".filter_order_Dir", 'filter_order_Dir',	'asc',	'word' );
		$newFilterId = JRequest::getVar('filter_id');
		$newSearch = JRequest::getVar('search');
		if((!empty($newSearch)&&$newSearch!=$app->getUserState($this->context.".search"))||(!empty($newFilterId) && $newFilterId!=$app->getUserState($this->context.".filter_id"))){
			$app->setUserState( $this->context.'.limitstart',0);
			$pageInfo->limit->start = 0;
		}else{
			$pageInfo->limit->start = $app->getUserStateFromRequest( $this->context.'.limitstart', 'limitstart', 0, 'int' );
		}
		$pageInfo->search = $app->getUserStateFromRequest( $this->context.".search", 'search', '', 'string' );
		$pageInfo->search = JString::strtolower( $pageInfo->search );

		$pageInfo->limit->value = $app->getUserStateFromRequest( $this->context.'.list_limit', 'limit', $app->getCfg('list_limit'), 'int' );
		if(empty($pageInfo->limit->value)) $pageInfo->limit->value = 500;
		$selectedType = $app->getUserStateFromRequest( $this->context.".filter_type",'filter_type',$config->get('sub_products_display_all',0),'int');
		$pageInfo->selectedType = $selectedType;
		$pageInfo->filter->filter_id = $app->getUserStateFromRequest( $this->context.".filter_id",'filter_id',0,'string');
		$pageInfo->filter->filter_product_type = $app->getUserStateFromRequest( $this->context.".filter_product_type",'filter_product_type','main','word');
		$pageInfo->filter->filter_published = $app->getUserStateFromRequest( $this->context.".filter_published",'filter_published',0,'int');
		$pageInfo->filter->filter_manufacturer = $app->getUserStateFromRequest( $this->context.".filter_manufacturer",'filter_manufacturer','','string');
		$database	= JFactory::getDBO();
		$filters = array();


		if($pageInfo->filter->filter_published==2){
			$filters[]='b.product_published=1';
		}elseif($pageInfo->filter->filter_published==1){
			$filters[]='b.product_published=0';
		}

		if(empty($pageInfo->filter->filter_id)|| !is_numeric($pageInfo->filter->filter_id)){
			$pageInfo->filter->filter_id='product';
			$class = hikashop_get('class.category');
			$class->getMainElement($pageInfo->filter->filter_id);
		}

		$manufacturerDisplay = hikashop_get('type.manufacturer');
		$manufacturer = $manufacturerDisplay->display('filter_manufacturer',$pageInfo->filter->filter_manufacturer);
		// $this->assignRef('manufacturerDisplay',$manufacturer);

		if (!empty($manufacturer))
		{
			if(!empty($pageInfo->filter->filter_manufacturer))
			{
				if($pageInfo->filter->filter_manufacturer=='none')
					$filters[]='b.product_manufacturer_id = 0';
				else if ($pageInfo->filter->filter_manufacturer!='')
					$filters[]='b.product_manufacturer_id='.(int)$pageInfo->filter->filter_manufacturer;
			}
		}

		$order = '';
		$categoryClass = hikashop_get('class.category');
		if(!$selectedType){
			$filters[]='a.category_id='.(int)$pageInfo->filter->filter_id;
			$select='SELECT a.*, b.*, c.category_name, a.product_id as id';
			$cat_ids = array((int)$pageInfo->filter->filter_id);
		}else{
			$categoryClass->parentObject =& $this;
			$childs = $categoryClass->getChilds((int)$pageInfo->filter->filter_id,true,array(),'',0,0);
			$filter = 'a.category_id IN (';
			$cat_ids = array();
			foreach($childs as $child){
				$filter .= $child->category_id.',';
				$cat_ids[$child->category_id]=$child->category_id;
			}
			$filters[]=$filter.(int)$pageInfo->filter->filter_id.')';
			$select='SELECT DISTINCT b.*';
		}

		$searchMap = array('b.product_name','b.product_description','b.product_id','b.product_code');

		$fieldsClass = hikashop_get('class.field');
		$parent_cat_ids = array();
		if(!empty($cat_ids)){
			$parents = $categoryClass->getParents($cat_ids,true,array(),'',0,0);
			if(!empty($parents)){
				foreach($parents as $parent){
					$parent_cat_ids[]=$parent->category_id;
				}
			}
		}
		$categories=array('originals'=>$cat_ids,'parents'=>$parent_cat_ids);

		$fields = $fieldsClass->getData('backend_listing','product',false,$categories);
		// $this->assignRef('fields',$fields);

		// $this->assignRef('fieldsClass',$fieldsClass);


		if(!empty($fields)){
			foreach($fields as $field){
				$searchMap[]='b.'.$field->field_namekey;
			}
		}


		if(!empty($pageInfo->search)){
			$searchVal = '\'%'.hikashop_getEscaped($pageInfo->search,true).'%\'';
			$filters[] = '('.implode(" LIKE $searchVal OR ",$searchMap)." LIKE $searchVal".')';
		}


		if($pageInfo->filter->filter_product_type=='all'){
			if(!empty($pageInfo->filter->order->value)){
				$select.=','.$pageInfo->filter->order->value.' as sorting_column';
				$order = ' ORDER BY sorting_column '.$pageInfo->filter->order->dir;
			}
		}else{
			if(!empty($pageInfo->filter->order->value)){
				$order = ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir;
			}
		}

		JPluginHelper::importPlugin( 'hikashop' );
		$dispatcher = JDispatcher::getInstance();
		$dispatcher->trigger( 'onBeforeProductListingLoad', array( & $filters, & $order, &$this, & $select, & $select2, & $a, & $b, & $on) );

		if($pageInfo->filter->filter_product_type=='all'){
			$query = '( '.$select.' FROM '.hikashop_table('product_category').' AS a LEFT JOIN '.hikashop_table('product').' AS b ON a.product_id=b.product_id WHERE '.implode(' AND ',$filters).' AND b.product_id IS NOT NULL )
			UNION
						( '.$select.' FROM '.hikashop_table('product_category').' AS a LEFT JOIN '.hikashop_table('product').' AS b ON a.product_id=b.product_parent_id LEFT JOIN '.hikashop_table('category').' AS c ON a.product_category_id=c.category_id WHERE '.implode(' AND ',$filters).' AND b.product_parent_id IS NOT NULL ) ';
			$database->setQuery($query.$order,(int)$pageInfo->limit->start,(int)$pageInfo->limit->value);
		}else{
			$filters[]='b.product_type = '.$database->Quote($pageInfo->filter->filter_product_type);
			if($pageInfo->filter->filter_product_type!='variant'){
				$lf = 'a.product_id=b.product_id';
			}else{
				$lf = 'a.product_id=b.product_parent_id';
			}
			$query = ' FROM '.hikashop_table('product_category').' AS a LEFT JOIN '.hikashop_table('product').' AS b ON '.$lf.' LEFT JOIN '.hikashop_table('category').' AS c ON a.product_category_id=c.category_id WHERE '.implode(' AND ',$filters);

			$database->setQuery($select.$query.$order,(int)$pageInfo->limit->start,(int)$pageInfo->limit->value);
		}

		$rows = $database->loadObjectList();
		$fieldsClass->handleZoneListing($fields,$rows);
		if(!empty($pageInfo->search)){
			$rows = hikashop_search($pageInfo->search,$rows,'product_id');
		}
		
		// set the pagination
		$database->setQuery('SELECT COUNT(DISTINCT(b.product_id))'.$query);
		jimport('joomla.html.pagination');
		$limit = $app->getUserStateFromRequest($this->context.'.limit', 'limit', $app->getCfg('list_limit'), 'int' );
        $limitstart = $app->getUserStateFromRequest($this->context.'.limitstart', 'limitstart', 0, 'int' );
        $this->pagination = new JPagination($database->loadResult(), $limitstart, $limit);
		
		return $rows;
    }
}
