<?php
/**
 * @name		Menu Manager CK
 * @package		com_menumanagerck
 * @copyright	Copyright (C) 2014. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 * @author		Cedric Keiflin - http://www.template-creator.com - http://www.joomlack.fr
 */

defined('_JEXEC') or die;
jimport('joomla.application.component.modellist');
require_once (JPATH_ROOT.'/administrator/components/com_menumanagerck/models/custom.php');
require_once (JPATH_SITE.'/components/com_jshopping/lib/factory.php'); 
require_once (JPATH_SITE.'/components/com_jshopping/lib/jtableauto.php');
require_once (JPATH_SITE.'/components/com_jshopping/tables/config.php'); 
require_once (JPATH_SITE.'/components/com_jshopping/lib/functions.php');
require_once (JPATH_SITE.'/components/com_jshopping/lib/multilangfield.php');
require_once (JPATH_ADMINISTRATOR.'/components/com_jshopping/models/categories.php'); 
JTable::addIncludePath(JPATH_SITE.'/components/com_jshopping/tables'); 

class MenumanagerckModelCustomjshoppingcategory extends MenumanagerckModelCustom
{
	protected $context = 'com_menumanagerck.customjshoppingcategory';
	
	public $pagination;

	public function __construct($config = array())
	{
		parent::__construct($config);
	}
	
	public function showSearchBar()
	{
		return true;
	}
	
	public function getCustomColumn()
	{
		return Array('title' => null, 'tag' => null, 'sort' => null);
	}
	
	public function getOrderingColumn()
	{
		return Array('title' => JText::_('JGRID_HEADING_ORDERING'), 'tag' => 'ordering', 'sort' => 'a.ordering');
	}
	
	public function getCustomFilters()
	{
		$app = JFactory::getApplication();

		// filter for parent category
		$categories_select = buildTreeCategory(0,1,0);
		$category_id = $app->getUserStateFromRequest($this->context.'.filter.categoryid', 'categoryid', 0, 'int');
		$customfilters = '<select name="filter_categoryid" class="input-medium" onchange="this.form.submit()">'
			. '<option value="0">- ' . JText::_('JCATEGORY') . ' -</option>'
			. JHtml::_('select.options', $categories_select, 'category_id', 'name', $this->state->get('filter.categoryid'))
		. '</select>';

		return $customfilters;
	}
	
	public function getItems()
	{
		$app = JFactory::getApplication();

		$model = JModelLegacy::getInstance('Categories', 'JshoppingModel');
		$categoryroot = $app->getUserStateFromRequest($this->context.'.filter.categoryid', 'categoryid', 0, 'int');
		$categorydepth = 0;
		$text_search = $app->getUserStateFromRequest($this->context.'.search', 'filter_search', '');
		$filter = array("text_search" => $text_search);
		$limit = $app->getUserStateFromRequest($this->context.'.limit', 'limit', $app->getCfg('list_limit'), 'int' );
        $limitstart = $app->getUserStateFromRequest($this->context.'.limitstart', 'limitstart', 0, 'int' );
        $filter_order = $app->getUserStateFromRequest($this->context.'.order', 'filter_order', "ordering", 'cmd');
        $filter_order_Dir = $app->getUserStateFromRequest($this->context.'order_Dir', 'filter_order_Dir', "asc", 'cmd');

		if ( $categoryroot || $categorydepth) {
			$categories = $this->getTreeSubCategories($categoryroot, 1, $categorydepth);
		} else {
			$categories = $this->getTreeAllCategories($filter, $filter_order, $filter_order_Dir);
		}
        
		$total = count($categories);
		jimport('joomla.html.pagination');
		$this->pagination = new JPagination($total, $limitstart, $limit);
		$countproducts = $this->getAllCatCountProducts();
		$categories = array_slice($categories, $this->pagination->limitstart, $this->pagination->limit);

		return $categories;
	}
	
	public function getObjectAssociation() {
		$names = new stdClass();
		$names->title = 'name';
		$names->level = 'level';
		$names->language = 'language';
		$names->id = 'category_id';

		return $names;
	}

	private function getTreeSubCategories($categoryroot, $level, $categorydepth) {
		$category = JTable::getInstance('category', 'jshop');        
		$category->load($category_id);
		$model = JModelLegacy::getInstance('Categories', 'JshoppingModel');

		$subcatsCount = $model->getAllCatCountSubCat();
		$cats = $category->getSubCategories($categoryroot);
		$items = Array();

		foreach ($cats as $cat) {
			$cat->level = $level;
			$items[] = $cat;
			if ($subcatsCount[$cat->category_id] && ($categorydepth == 0 || $categorydepth > ($level+1)) ) {
				$subcats = self::getTreeSubCategories($cat->category_id, $cat->level + 1, $categorydepth);
				foreach ($subcats as $subcat) {
					$items[] = $subcat;
				}
			}
		}
		return $items;
	}

	public function getState($property = null, $default = null)
	{
		$this->populateState();

		return $property === null ? $this->state : $this->state->get($property, $default);
	}

	protected function populateState($ordering = null, $direction = null)
	{
		$app = JFactory::getApplication();

		$search = $this->getUserStateFromRequest($this->context . '.search', 'filter_search');
		$this->setState('filter.search', $search);
		$this->setState('filter.categoryid', $this->getUserStateFromRequest($this->context . '.filter.categoryid', 'filter_categoryid', 0));
		$this->setState('list.limit', $this->getUserStateFromRequest($this->context.'.limit', 'limit', $app->getCfg('list_limit'), 'int' ));
		// List state information.
		$filter_order = $app->getUserStateFromRequest($this->context.'filter_order', 'filter_order', "id", 'cmd');
		$filter_order_Dir = $app->getUserStateFromRequest($this->context.'filter_order_Dir', 'filter_order_Dir', "asc", 'cmd');
		parent::populateState($filter_order, $filter_order_Dir);

	}

	protected function getStoreId($id = '')
	{
		// Compile the store id.
		$id .= ':' . $this->getState('filter.search');
		$id .= ':' . $this->getState('filter.extension');
		$id .= ':' . $this->getState('filter.published');
		$id .= ':' . $this->getState('filter.language');

		return parent::getStoreId($id);
	}

	public function getPagination()
	{
		return $this->pagination;
	}

	/*function getAllList($display=0){
        $db = JFactory::getDBO();        
        $lang = JSFactory::getLang();
        if (isset($order) && $order=="id") $orderby = "`category_id`";
        if (isset($order) && $order=="name") $orderby = "`".$lang->get('name')."`";
        if (isset($order) && $order=="ordering") $orderby = "ordering";
        if (isset($orderby) && !$orderby) $orderby = "ordering";
        $query = "SELECT `".$lang->get('name')."` as name, category_id FROM `#__jshopping_categories` ORDER BY ordering";
        $db->setQuery($query);        
        $list = $db->loadObjectList();
        if ($display==1){
            $rows = array();
            foreach($list as $k=>$v){
                $rows[$v->category_id] = $v->name;    
            }
            unset($list);
            $list = $rows;
        }
        return $list;
    }*/
    
    function getSubCategories($parentId, $order = 'id', $ordering = 'asc') {
        $db = JFactory::getDBO();        
        $lang = JSFactory::getLang();
        if ($order=="id") $orderby = "`category_id`";
        if ($order=="name") $orderby = "`".$lang->get('name')."`";
        if ($order=="ordering") $orderby = "ordering";
        if (!$orderby) $orderby = "ordering";
        $query = "SELECT `".$lang->get('name')."` as name,`".$lang->get('short_description')."` as short_description, category_id, category_publish, ordering, category_image FROM `#__jshopping_categories`
                   WHERE category_parent_id = '".$db->escape($parentId)."'
                   ORDER BY ".$orderby." ".$ordering;
        $db->setQuery($query);        
        return $db->loadObjectList();
    }
    
    function getAllCatCountSubCat() {
        $db = JFactory::getDBO();        
        $query = "SELECT C.category_id, count(C.category_id) as k FROM `#__jshopping_categories` as C
                   inner join  `#__jshopping_categories` as SC on C.category_id=SC.category_parent_id
                   group by C.category_id";
        $db->setQuery($query);
        $list = $db->loadObjectList();
        $rows = array();
        foreach($list as $row){
            $rows[$row->category_id] = $row->k;
        }        
        return $rows;
    }
    
    function getAllCatCountProducts(){
        $db = JFactory::getDBO();    
        $query = "SELECT category_id, count(product_id) as k FROM `#__jshopping_products_to_categories` group by category_id";
        $db->setQuery($query);
        $list = $db->loadObjectList();
        $rows = array();
        foreach($list as $row){
            $rows[$row->category_id] = $row->k;
        }        
        return $rows;
    }
    /*
    function deleteCategory($category_id){
        $db = JFactory::getDBO();
        $query = "DELETE FROM `#__jshopping_categories` WHERE `category_id` = '" . $db->escape($category_id) . "'";
        $db->setQuery($query);
        $db->query();
    }*/
    
    function getTreeAllCategories($filter = array(), $order = null, $orderDir = null) {
        $db = JFactory::getDBO();
        $user = JFactory::getUser();
        $lang = JSFactory::getLang();

        $query = "SELECT ordering, category_id, category_parent_id, `".$lang->get('name')."` as name, `".$lang->get('short_description')."` as short_description, `".$lang->get('description')."` as description, category_publish, category_image FROM `#__jshopping_categories`
                  ORDER BY category_parent_id, ". $this->_allCategoriesOrder($order, $orderDir);
        $db->setQuery($query);
        $all_cats = $db->loadObjectList();

        $categories = array();
        if (count($all_cats)){
            foreach($all_cats as $key=>$category){
                $category->isPrev = 0; $category->isNext = 0;
                if (isset($all_cats[$key-1]) && $category->category_parent_id == $all_cats[$key-1]->category_parent_id){
                    $category->isPrev = 1;
                }
                if (isset($all_cats[$key+1]) && $category->category_parent_id == $all_cats[$key+1]->category_parent_id){
                    $category->isNext = 1;
                }
                
                if (!$category->category_parent_id){
                    recurseTree($category, 1, $all_cats, $categories, 0);
                }
            }
        }

        if (count($categories)){
			if (isset($filter['text_search']) && !empty($filter['text_search'])){
                $originalCategories = $categories;
                $filter['text_search'] = strtolower($filter['text_search']);

                foreach ($categories as $key => $category){
                    if (strpos(strtolower($category->name), $filter['text_search']) === false && strpos(strtolower($category->short_description), $filter['text_search']) === false && strpos(strtolower($category->description), $filter['text_search']) === false){
                        unset($categories[$key]);
                    }
                }

                if (count($categories)){
                    foreach ($categories as $key => $category){
                        // $categories[$key]->name = "<span class = 'jshop_green'>".$categories[$key]->name."</span>"; 
                        $category_parent_id = $category->category_parent_id;
                        $i = 0;
                        while ($category_parent_id || $i < 1000) {
                            foreach ($originalCategories as $originalKey => $originalCategory){
                                if ($originalCategory->category_id == $category_parent_id){
                                    $categories[$originalKey] = $originalCategory;
                                    $category_parent_id = $originalCategory->category_parent_id;
                                    break;
                                }
                            }
                            $i++;
                        }
                    }
                    
                    ksort($categories);
                }
            }
		
            foreach($categories as $key=>$category){
                $category->space = ''; 
                for ($i = 0; $i < $category->level; $i++){
                    $category->space .= '<span class = "gi">|</span>';
                }
            }
        }
		
        return $categories;
    }
   
    function _allCategoriesOrder($order = null, $orderDir = null){
        $lang = JSFactory::getLang();
        if ($order && $orderDir){
            $fields = array("name" => "`".$lang->get('name')."`", "id" => "`category_id`", "description" => "`".$lang->get('description')."`", "ordering" => "`ordering`");
            if (strtolower($orderDir) != "asc") $orderDir = "desc";
            if (!$fields[$order]) return "`ordering` ".$orderDir;
            return $fields[$order]." ".$orderDir;
        }else{
            return "`ordering` asc";
        }
    }
}
